using UnityEngine;
using System;
using System.Collections;

public enum ActionResult {
	SuccessOnlyAffectedSelf,
    SuccessOthersAffected,
	Abort
}

public class TurnAction
{
    public int Priority = 0;
    public ActionResult Result;

    public virtual void Perform()
    {
        Result = ActionResult.SuccessOnlyAffectedSelf;
    }
    public virtual Render GetRender()
    {
        return null;
    }
    public virtual void ShowProgress() { }
    public TurnAction FollowupAction = null;
    public void AppendToChain(TurnAction newAction)
    {
        if (FollowupAction == null)
            FollowupAction = newAction;
        else
            FollowupAction.AppendToChain(newAction);
    }
}
